Last Comment Bug 791051 - Session restore won't fail if there are no tabs in JSON
: Session restore won't fail if there are no tabs in JSON
Status: VERIFIED FIXED
:
Product: Firefox for Android
Classification: Client Software
Component: General (show other bugs)
: unspecified
: ARM Android
: -- normal (vote)
: Firefox 18
Assigned To: Brian Nicholson (:bnicholson)
:
Mentors:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2012-09-13 11:45 PDT by Brian Nicholson (:bnicholson)
Modified: 2012-09-20 12:01 PDT (History)
4 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---
affected
verified
fixed
verified


Attachments
Make sure tab exists for session restore (1.01 KB, patch)
2012-09-13 11:45 PDT, Brian Nicholson (:bnicholson)
mark.finkle: review+
lukasblakk+bugs: approval‑mozilla‑aurora+
lukasblakk+bugs: approval‑mozilla‑beta+
lukasblakk+bugs: approval‑mozilla‑release-
Details | Diff | Review

Description Brian Nicholson (:bnicholson) 2012-09-13 11:45:04 PDT
Created attachment 660916 [details] [diff] [review]
Make sure tab exists for session restore

I ran into this while trying the STR in bug 789867:
1) Open Fennec
2) Go to any page
3) Push home and OOM Fennec
4) Reopen Fennec
5) While Fennec is loading, repeatedly hit the stop button to prevent the page from loading
6) Once the throbber has stopped and at a blank screen, push home and OOM Fennec again
7) Reopen Fennec

This results in the following sessionstore state:
{"windows":[{"tabs":[],"selected":1,"closedTabs":[]}]}

which happens because we clear the session data at startup, and we stopped the restored tab from loading, so no tabs get added. After step 7 above, the throbber spins endlessly and nothing loads in the browser. We should make sure there's at least one tab being restored.
Comment 1 Brian Nicholson (:bnicholson) 2012-09-13 14:13:54 PDT
http://hg.mozilla.org/integration/mozilla-inbound/rev/9a7b25bc580e
Comment 2 Brian Nicholson (:bnicholson) 2012-09-13 14:15:47 PDT
Comment on attachment 660916 [details] [diff] [review]
Make sure tab exists for session restore

[Approval Request Comment]
Regression caused by (bug #): 
User impact if declined: Startup could hang (the throbber loops forever and the user can't load any pages)
Testing completed (on m-c, etc.): just landed
Risk to taking this patch (and alternatives if risky): very low
Comment 3 Ryan VanderMeulen [:RyanVM] 2012-09-13 18:57:11 PDT
https://hg.mozilla.org/mozilla-central/rev/9a7b25bc580e
Comment 4 Lukas Blakk [:lsblakk] use ?needinfo 2012-09-14 15:28:32 PDT
Setting status-firefox18 to fixed - Scoobidiver we are going to rely on status flags more than Target Milestones in the future so the best practice is not to clear a flag, but to set to fixed.
Comment 5 Lukas Blakk [:lsblakk] use ?needinfo 2012-09-14 15:29:38 PDT
Comment on attachment 660916 [details] [diff] [review]
Make sure tab exists for session restore

We're not re-building 15 for this so minus on mozilla-release approval request.
Comment 6 Brian Nicholson (:bnicholson) 2012-09-17 15:59:29 PDT
http://hg.mozilla.org/releases/mozilla-aurora/rev/7328213574c2
Comment 7 Brian Nicholson (:bnicholson) 2012-09-17 16:01:18 PDT
http://hg.mozilla.org/releases/mozilla-beta/rev/0d33f954ee14

Note You need to log in before you can comment on or make changes to this bug.